package org.xbib.event.queue.path.watch;

import org.xbib.event.queue.QueueEvent;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.StandardCopyOption;
import java.nio.file.attribute.FileTime;
import java.time.Instant;

public class PathQueueEvent extends QueueEvent {

    static final String INCOMING = "incoming";

    static final String SUCCESS = "success";

    static final String FAIL = "fail";

    private Path path;

    private Path file;

    private String suffix;

    public void setFile(Path file) {
        this.file = file;
    }

    public Path getFile() {
        return file;
    }

    public void setPath(Path path) {
        this.path = path;
    }

    public Path getPath() {
        return path;
    }

    public void setSuffix(String suffix) {
        this.suffix = suffix;
    }

    public String getSuffix() {
        return suffix;
    }

    public void success() throws IOException {
        Files.setLastModifiedTime(file, FileTime.from(Instant.now()));
        Files.move(file, path.resolve(SUCCESS).resolve(file.getFileName()).toAbsolutePath(),
                StandardCopyOption.REPLACE_EXISTING);
    }

    public void fail() throws IOException {
        Files.setLastModifiedTime(file, FileTime.from(Instant.now()));
        Files.move(file, path.resolve(FAIL).resolve(file.getFileName()).toAbsolutePath(),
                StandardCopyOption.REPLACE_EXISTING);
    }
}
