package org.xbib.event.yield.ops;

import org.xbib.event.yield.Advancer;
import org.xbib.event.yield.Query;
import org.xbib.event.yield.Traverser;
import org.xbib.event.yield.Yield;
import org.xbib.event.yield.boxes.BoolBox;

import java.util.function.Predicate;

public class Filter<T> implements Advancer<T>, Traverser<T> {

    private final Query<T> upstream;

    private final Predicate<? super T> p;

    public Filter(Query<T> adv, Predicate<? super T> p) {
        this.upstream = adv;
        this.p = p;
    }

    @Override
    public void traverse(Yield<? super T> yield) {
        upstream.traverse(e -> {
            if (p.test(e))
                yield.ret(e);
        });
    }

    @Override
    public boolean tryAdvance(Yield<? super T> yield) {
        BoolBox found = new BoolBox();
        while (found.isFalse()) {
            boolean hasNext = upstream.tryAdvance(item -> {
                if (p.test(item)) {
                    yield.ret(item);
                    found.set();
                }
            });
            if (!hasNext) break;
        }
        return found.isTrue();
    }
}
