package org.xbib.event.yield.ops;

import org.xbib.event.yield.Advancer;
import org.xbib.event.yield.Traverser;
import org.xbib.event.yield.Yield;

public class FromArray<U> implements Advancer<U>, Traverser<U> {

    private final U[] data;

    private int current;

    @SuppressWarnings("unchecked")
    public FromArray(U... data) {
        this.data = data;
        this.current = 0;
    }

    public boolean hasNext() {
        return current < data.length;
    }

    /**
     * Continues from the point where tryAdvance or next left the
     * internal iteration.
     *
     * @param yield yield
     */
    @Override
    public void traverse(Yield<? super U> yield) {
        for (int i = current; i < data.length; i++) {
            yield.ret(data[i]);
        }
    }

    @Override
    public boolean tryAdvance(Yield<? super U> yield) {
        if (!hasNext()) return false;
        yield.ret(data[current++]);
        return true;
    }
}
