package org.xbib.event.yield.ops;

import org.xbib.event.yield.Advancer;
import org.xbib.event.yield.Traverser;
import org.xbib.event.yield.Yield;

import java.util.function.Supplier;

public class Generate<U> implements Advancer<U>, Traverser<U> {

    private final Supplier<U> s;

    public Generate(Supplier<U> s) {
        this.s = s;
    }

    @Override
    public void traverse(Yield<? super U> yield) {
        while (true) {
            yield.ret(s.get());
        }
    }

    @Override
    public boolean tryAdvance(Yield<? super U> yield) {
        yield.ret(s.get());
        return true;
    }
}
