package org.xbib.event.yield.ops;

import org.xbib.event.yield.Advancer;
import org.xbib.event.yield.Query;
import org.xbib.event.yield.Traverser;
import org.xbib.event.yield.Yield;

import java.util.function.Function;

public class Mapping<T, R> implements Advancer<R>, Traverser<R> {

    private final Query<T> upstream;

    private final Function<? super T, ? extends R> mapper;

    public Mapping(Query<T> adv, Function<? super T, ? extends R> mapper) {
        this.upstream = adv;
        this.mapper = mapper;
    }

    @Override
    public void traverse(Yield<? super R> yield) {
        upstream.traverse(e -> yield.ret(mapper.apply(e)));
    }

    @Override
    public boolean tryAdvance(Yield<? super R> yield) {
        return upstream.tryAdvance(item -> yield.ret(mapper.apply(item)));
    }
}
