package org.xbib.event.yield.ops;

import org.xbib.event.yield.Advancer;
import org.xbib.event.yield.Query;
import org.xbib.event.yield.Traverser;
import org.xbib.event.yield.Yield;

public class Skip<T> implements Advancer<T>, Traverser<T> {

    private final Query<T> upstream;

    private final int n;

    int index;

    public Skip(Query<T> adv, int n) {
        this.upstream = adv;
        this.n = n;
        index = 0;
    }

    /**
     * Continues from the point where tryAdvance or next left the
     * internal iteration.
     *
     * @param yield the yield
     */
    @Override
    public void traverse(Yield<? super T> yield) {
        upstream.traverse(item -> {
            if (index++ >= n)
                yield.ret(item);
        });
    }

    @Override
    public boolean tryAdvance(Yield<? super T> yield) {
        for (; index < n; index++)
            upstream.tryAdvance(item -> {
            });
        return upstream.tryAdvance(yield);
    }
}
