package org.xbib.event.yield.primitives.intgr.ops;

import org.xbib.event.yield.primitives.intgr.IntAdvancer;
import org.xbib.event.yield.primitives.intgr.IntQuery;
import org.xbib.event.yield.primitives.intgr.IntTraverser;
import org.xbib.event.yield.primitives.intgr.IntYield;

import java.util.function.IntConsumer;

public class IntPeek implements IntAdvancer, IntTraverser {
    private final IntQuery upstream;
    private final IntConsumer action;

    public IntPeek(IntQuery adv, IntConsumer action) {
        this.upstream = adv;
        this.action = action;
    }

    @Override
    public void traverse(IntYield yield) {
        upstream.traverse(item -> {
            action.accept(item);
            yield.ret(item);
        });
    }

    @Override
    public boolean tryAdvance(IntYield yield) {
        return upstream.tryAdvance(item -> {
            action.accept(item);
            yield.ret(item);
        });
    }
}
