package org.xbib.event.clock;

import org.junit.jupiter.api.Test;
import org.xbib.event.EventManager;
import org.xbib.settings.Settings;

import java.io.IOException;
import java.util.logging.Logger;

public class ClockEventManagerTest {

    @Test
    public void testEvents() throws IOException, InterruptedException {
        TestClockEventConsumer clockEventConsumer = new TestClockEventConsumer();
        EventManager.register(clockEventConsumer);
        Settings settings = Settings.settingsBuilder()
                .put("event.clock.testclockevent.enabled", "true")
                .put("event.clock.testclockevent.class", "org.xbib.event.clock.TestClockEvent")
                .put("event.clock.testclockevent.entry", "*/1 6-21 * * *")
                .build();
        EventManager eventManager = EventManager.newEventManager(settings);
        ClockEventManager clockEventManager = eventManager.getClockEventManager();
        Thread.sleep(90000L);
        clockEventManager.close();
    }
}
