package org.xbib.event.timer;

import org.junit.jupiter.api.Test;
import org.xbib.event.EventManager;
import org.xbib.settings.Settings;

import java.io.IOException;
import java.time.Instant;
import java.util.Map;

public class TimerEventManagerTest {

    @Test
    public void testTimerEvents() throws IOException, InterruptedException {
        TestTimerEventConsumer consumer = new TestTimerEventConsumer();
        EventManager.register(consumer);
        Settings settings = Settings.settingsBuilder()
                .put("event.timer.testtimerevent.enabled", "true")
                .put("event.timer.testtimerevent.class", "org.xbib.event.timer.TestTimerEvent")
                .build();
        EventManager eventManager = EventManager.newEventManager(settings);
        TimerEventManager timerEventManager = eventManager.getTimerEventManager();
        timerEventManager.put("testtimerevent", Instant.now().plusSeconds(5L), Map.of("a", "b"));
        Thread.sleep(10000L);
        timerEventManager.close();
    }
}
